View Issue Details

This bug affects 1 person(s).
 22
IDProjectCategoryView StatusLast Update
07367Feature requestsSurvey editingpublic2022-05-24 17:04
Reporterjelo Assigned To 
PrioritynormalSeverityfeature 
Status ready for code reviewResolutionopen 
Summary07367: "Other answer" at a certain position in the list
Description

If you have "No answer" globally deactivated, you sometimes add an item "No answer" by hand to certain questions.

If you then want to use "other answer", the position of "other answer" is below "No answer".

So it would be a common feature to allow "Other answer" at a certain position in the list.

The most flexible way, would be to allow a "Other answer" field behind every item in the list.

Additional Information

A possible solution: Checkboxes behind the item list
First idea would be to set position via checkboxes behind the item list, which would mean that the other box is displayed below this item.

The idea to allow to display a "other answers" behind every item would need additional fields beside the checkboxes.

TagsNo tags attached.
Bug heat22

Relationships

related to 11988 new Feature requests Allow order of answers and sub question in 'the way admin user want' 

Users monitoring this issue

User List tixeon, mfaber

Activities

c_schmitz

c_schmitz

2009-11-11 13:33

administrator   ~24317

Alternative solution: Make the global 'No answer' option question-specific
I guess the better change would be to make the global 'no answer' option available per question. That way you can use it when you need it. This new option should only by available if question is set to be not mandatory.

jelo

jelo

2009-11-11 18:21

partner   ~24318

Last edited: 2021-11-25 10:22

Think the survey designer can take care if the "no answer" option should be used in a mandatory question. And why should the option only be shown if the question is "not mandatory"? If the question is not mandatory most survey designer wouldn't want a dedicated "no answer" option.

BTW:
The multioption list question has the option for other answer / additional comment behind every single item. Wordaround is to hide certain fields via CSS to get the fields only behind certain fields. Something for radiooption list is missing. But I think that might a third solution.

jelo

jelo

2013-08-30 13:09

partner   ~26113

Last edited: 2021-11-25 10:22

A few years have passed. The feature request to allow a free text field behind certain items still stands. To allow a activation per question is ok for the automatic OtherField, but not for the item specific fields.

If you want a other field behind two items of e.g. 5 items radion button question you need to do a workaround with a few extra questions.

Perhaps consider a free format question where a few questions types could be mixed into a certain layout to mimic certain questiontypes.

jelo

jelo

2014-12-05 16:17

partner   ~31183

Last edited: 2021-11-25 10:22

Putting "None of the Above" last on a list (even after 'Other')
http://www.aptigence.com.au/site/node/11

Was there any reason to do it that way? Other after No answer seems to be a bad idea.

If certain fields could be excluded from randomization, it would be possible to add a None of the above/No answer as an item per hand.

jelo

jelo

2015-06-16 00:42

partner   ~32375

Last edited: 2021-11-25 10:22

In the light of 2.06 and 3.0 defining the scope what about a 'No answer' option question-specific and more that one other field in questions?

holch

holch

2015-08-11 17:40

reporter   ~32901

Last edited: 2021-11-25 10:22

I second this. It would be great if we could have a little more flexibility with the "other" boxes.

Ideally, there is a tick box for any answer option that will allow to display a comment field for any of the answer items, no matter were the item is positioned, 1st position, last, middle.

Often you need even more than one "other" comment box, because there might be different "others".

Mazi

Mazi

2015-08-14 10:58

updater   ~32955

Last edited: 2021-11-25 10:22

Since the Limesurvey developers are pretty overworked, let's start small and split this up into several issues we can implement step by step:

  1. Allow the user to place the "other" options at a certain position.

  2. Allowing several "other" fields:
    a) For the multiple choice question this is pretty easy by using "multiple choice with comments" question type" and allowing the user to just not display the text field for certain items.
    b) For the list radio question this probably means adjusting the whole question type with all side effects like adjusting

    • conditions
    • statistics
    • exporting results
    • importing results (VV import)
    • exporting surveys/groups/questions
    • importing surveys/groups/questions
    • ...

So let's start with #1, then work on #2a and put 2b on the list for 2022 :-)

Mazi

Mazi

2016-04-05 08:59

updater   ~36999

Last edited: 2021-11-25 10:22

For all those who want to place the "other" option at a certain position, check: http://www.limesurvey-consulting.com/how-to-re-order-the-other-option-at-a-limesurvey-survey/

jelo

jelo

2016-04-06 13:12

partner   ~37039

Last edited: 2021-11-25 10:22

The whole Issue Community Support Voting isn't working.
c_schmitz is rejecting this feature request. Is the idea or the implementation?
That's the problem when moving the feature requests to this tool in the beginning.
A discussion thread for every feature request to define a feature request with implementation path seems to be needed to allow a voting here.

trivender

trivender

2016-04-13 20:34

updater   ~37357

Last edited: 2021-11-25 10:22

Need this feature:
https://www.limesurvey.org/community-services/forums/future-features/94172-question-layout-designer#99207

jelo

jelo

2016-09-25 22:41

partner   ~40951

Last edited: 2021-11-25 10:22

The GUI should provide a other field drop-down box behind every answer-item.
Via the drop-downfield you can define what kind of other field should be used.
One line, multiple lines, numbers, numbers (integer), date, time.

See the attached screenshot for real life example.

otherfields.editor.JPG (76,267 bytes)   
otherfields.editor.JPG (76,267 bytes)   
DenisChenu

DenisChenu

2016-12-02 11:14

developer   ~42314

Last edited: 2021-11-25 10:22

Seems related (but not totally) with https://framagit.org/SondagePro-LimeSurvey-plugin/moveSomeAnswers/blob/master/README.md

DenisChenu

DenisChenu

2016-12-07 15:16

developer   ~42446

Last edited: 2021-11-25 10:22

I preder a more global solution : https://bugs.limesurvey.org/view.php?id=11988

DenisChenu

DenisChenu

2016-12-07 15:22

developer   ~42447

Last edited: 2021-11-25 10:22

PS : the screenshot show more a 'List of updatable question type' : i really think it's a must have too.

jelo

jelo

2016-12-07 16:05

partner   ~42453

Last edited: 2021-11-25 10:22

I had widen the scope of my feature request. Position of other field and more than one other field. I will follow your global solution for positioning.
https://bugs.limesurvey.org/view.php?id=11988

tixeon

tixeon

2019-08-06 01:58

reporter   ~53118

Last edited: 2021-11-25 10:22

I prefer to be able to chose the position in the list for other. Sometimes there are 2 options I want below it (not relevant to me, Don't know), or even 3.

joka77

joka77

2020-12-04 16:30

reporter   ~60840

Last edited: 2021-11-25 10:22

"Allow the user to place the "other" options at a certain position"

I think this is still highly relevant and it would be a nice feature to add this. For exmaple, consider a muliple choice question, where you have different "Yes" answers that add some explanation, e.g.

Question:
Are you planning to provide some information about the results of your project?
Answer options:
Yes, on the project website
Yes, on public events
etc.
Yes, and that is: ____ [other option]
No

Sometimes you want to give the option to add something in case there is no suitable answer provided in the list. It is just easier and more convenient from my point of view to have an option to fill in the answer directly (instad of adding another list type question or text type question afterwards). And it certainly looks a bit weird if you place the "No" option before the "other" option in that example, and that is how it would look like if you wanted to implement this question in LimeSurvey right now.

Mazi

Mazi

2020-12-04 17:33

updater   ~60841

Last edited: 2021-11-25 10:22

For Limesurvey 3 there is a plugin available to position the "other" free text field anywhere: https://survey-consulting.com/product/limesurvey-plugin-change-other-position

tixeon

tixeon

2020-12-04 22:37

reporter   ~60842

Last edited: 2021-11-25 10:22

This discussion links to the one about the other specify not working as it should over here: https://bugs.limesurvey.org/view.php?id=16157#c60756

You can use javascript (attached) to move the location of the other specify (and just relabel it in the setting). However, this functionality doesn't work in an optimal way as it doesn't add a boolean / answer variable for the other option (= extra work in manual data transformations prior to analysis), and people can't tick the box, it only ticks if they start writing in the comment box, which gets construed as an error and results in respondent drop-outs / complaints.

Until this issue is fixed there is a rather elegant work-around which re-positions a short text question into the required comment box location: https://forums.limesurvey.org/forum/can-i-do-this-with-limesurvey/122927-multiple-response-other-that-can-be-ticked

Put other further up the list.txt (1,035 bytes)   
<script type="text/javascript" charset="utf-8">
       
        $(document).ready(function() {
       
                // The number of answers to be fixed at the end of the list
                var fixedAnswers = 1;
               
                // Identify this question
                var qID = {QID};
               
                // Find the number of answers
                var ansCount = $('#question'+qID+' li.answer-item').length;
               
                // Place the last n answers created at the end of the list
                var fixedIndex = fixedAnswers - 1;
                for (var i=0; i<fixedAnswers; i++) {
                        var answer = $( 'input[id$="X'+qID+(ansCount-fixedIndex)+'"]');
                        var answerItem = $(answer).closest('li');
                        var answersList = $(answer).closest('ul');
                        $(answersList).append(answerItem);
                        fixedIndex--;
                }              
        });
</script>
jelo

jelo

2020-12-05 11:53

partner   ~60843

Last edited: 2021-11-25 10:22

This feature request is 11 years old. I would expect that a feature request is confirmed or denied. If it is confirmed, what does 11 years tell us?
Nobody needs this features? So why not just close all old features requests?

LimeSurvey is more like an survey framework for developers (which like workarounds, plugins, tweaking code) than an survey tool for end users.
If you invest in LimeSurvey and workarounds, you can lose everything in the next version of LimeSurvey. The amount of dependencies for a "simple" survey can become pretty high.
That are hidden costs which other SaaS solutions don't have. I wonder how that will work in the SaaS market in the next years and what user problems LimeSurvey wants to solve.

jelo

jelo

2021-11-25 10:39

partner   ~67559

12 Years have passed. How much time does it take to make a singlechoice question with four options and different other fields behind these options? This one took me 15 seconds in a different SaaS tool. No workarounds, No added scripts. No plugins. Just one interface with four clicks. Just as an inspiration for GUI and workflow.

image.png (19,466 bytes)   
image.png (19,466 bytes)   
image-2.png (40,146 bytes)   
image-2.png (40,146 bytes)   
Mazi

Mazi

2021-11-25 12:02

updater   ~67568

@jelo, which tool is that?

jelo

jelo

2021-12-01 03:06

partner   ~67613

@Mazi: Lamapoll

gabrieljenik

gabrieljenik

2021-12-22 18:30

manager   ~67847

Our suggested approach:
Add new question setting: Other Position.
Dropdown. With the following options:

  • At begining
  • Before No Answer (show or not, according to question being mandatory and/or the global "no answer" setting)
  • At end
    After <answer option 1>
    After <answer option 2>
    ....

Problems / Questions:

1) Should this be a general option or an advanced option?
If "General" we should add a column to the question table, which doesn't sound great to me.

2) When renedering the drodpown we should keep it in sync with the answer options section (which is now in the same screen). Also with the mandatory setting.

Alternative approaches? Thoughts?

DenisChenu

DenisChenu

2021-12-22 18:35

developer   ~67848

For only «07367: "Other answer" at a certain position in the list»: QuestionTheme can do it

With 2 settings:

  • a select with Begining/Before No Answer /At end/ After "Answercode"
  • a string for answercode
gabrieljenik

gabrieljenik

2021-12-22 18:38

manager   ~67849

Yep, could work!

holch

holch

2021-12-22 18:50

reporter   ~67850

Why don't we just give the option with a tick box to add the "other"-field to ANY of the answers in a multiple or single choice question? Sometimes you want more than one other field. Let's make Limesurvey as flexible as possible. Why offering this option and the next feature request is: have more than one "other" field?

Just something like: "enable other" behind each answer option / subquestion?

gabrieljenik

gabrieljenik

2021-12-22 18:54

manager   ~67851

Well, that would require much more effort.
That's why could be better to leave it on separate requests as to prioritize them as needed.

holch

holch

2021-12-22 19:04

reporter   ~67852

Yeah, but why don't we do it right at the first place, than to fix a little bit just to wait another 15 years until we get more than one "other"-option in a question?

I mean, yes, having flexibility in the positioning would be already good, but we all know how it goes with features in Limesurvey. ;-)

And I don't think prioritizing best on effort needed is not always the best approach. Right now something will be implemented, that isn't needed anymore, when we have an "enable other" option for any answer option / subquestion. So while implementing this now would be quicker, it is useless once we implement what people really want. Just saying.

In total, this might be more work at the end. Now, if you give me these two options:

  1. Have this now and "enable other" in 10 years or
  2. Not having anything now and "enable other" in 5 years,

Then definitely 1, please. ;-)

DenisChenu

DenisChenu

2021-12-22 19:04

developer   ~67853

@holch : title is «07367: "Other answer" at a certain position in the list»

It's not : Allow multiple other :) or add any question between each choice (07367:67559 )

Other answer position : no DB update in Question system : only view (then it's QuestionTheme in my optionion)
Multiple other : need to create a DB column for each other ? Then : need to name it other1 other2 other2 ?
Any question type : need a complete rewrite of how question is saved if we need something easy for any user (javascript can already do it)

holch

holch

2021-12-22 19:19

reporter   ~67854

@Denis and @Gabriel: I totally understand. But I am wondering if it is really worth implementing this feature if we can basically solve more problems with the other approach. I admit, I am no expert on how much work this means more, I am coming from a user perspective and a usability perspective. I simply find the 'multiple other" approach the most flexible one and also the most userfriendly one. Just a click behind the answer option / subquestion and you have an other option where ever you want. I know this might have some impact on database design, etc., but I am just bringing the user perspective into this, because I feel that Limesurvey in general is a little too "developer driven". I can accept if at the end it is decided to go for the option that might not be ideal, but easier to implement, but I still think it is important to discuss this before and way the different arguments. At the end of the day, I know that the word of the developer will always way more, but I want to bring the user point of view to the attention at least.

holch

holch

2021-12-22 19:49

reporter   ~67855

Can't edit my answer, but "way" == "weigh". ;-)

jelo

jelo

2021-12-22 21:03

partner   ~67856

@holch: The solution is simple: Create a bugreport "Fix the crappy database structure to allow features like relevance equations on single-choice-questions and other fields behind every answer item" ;-) Will allow allow a lot of old feature requests to be finished.

DenisChenu

DenisChenu

2021-12-23 08:56

developer   ~67857

I think i already ask for a real QuestionSystem where DATABASE structure are inside the QuestionSystem ;)

My opinion are more : the only way to get real evolution like 07367:67559 are to create "'Extension" system.

@holch : you ask for multiple other option, but , why stop at this step ?

  1. Other type (date/number/list of choice)
  2. Multiple other by option : one date and long text (it's not in @jelo screenshot)
  3. etc …
    If you start with one you can broke other's …

For example : maybe best is to have 2 settings for all question : "Use this question as other for Question code" with "answer code"

The question is always «Where to stop» …
My opinion : don't stop, offer condition where other dev can offer great system. Where you can offer :

  1. Big LimeSurvey with a lot of QuestionType but complex to use
  2. Medium LimeSurvey with some question type
  3. Light LimeSurvey easy to understand and use.

Currently : there are no clean way for QuestionTheme and SurveyTheme to have translation. It must be fixed before another things. SurveyTheme can not add attribute (CSS Class is clearly a SurveyTheme related question attribute) etc …

jelo

jelo

2021-12-23 11:21

partner   ~67858

The whole feature request thing is a waste of time if you don't know what the mission of LimeSurvey is.
@DenisChenu: Currently, the development stops when the technical debt sets in.

The litmus test is very simple. Relevance equations were added to multiple-choice questions, but not to single choice questions.
The reason is technical debt.

Take it, change it or leave it is the current status. Which is totally fine. But for a SaaS offer it's will limit the userbase to a certain level of willingness to pay. 5 minutes for an untrained user vs. 5 hours reading posts and modifying workarounds is a simple business case if you can choose between solutions. The students which are forced to use LimeSurvey will stay. The OnPremise business case will stay valid too.

I wonder if the main milestone is still the WYSIWYG edit feature. A good example for a WYSIWYG UX is Surveyking.

image-3.png (50,104 bytes)   
image-3.png (50,104 bytes)   
Mazi

Mazi

2022-04-28 12:46

updater   ~69283

I'd like to share some feedback from our trainings: Especially people creating many surveys or having worked with other tools mention a lack of certain feature like https://bugs.limesurvey.org/view.php?id=9774 and missing flexibility. Typical questions are "Why can't I change the position of the other free text field?" and "How can I have text fields for sub-questions at array items".
Since both requests are rather common, we are now demonstrating our plugins for this at the trainings. Of course, on the one hand this is to earn some additional money, but on the other hand we do not want to see disappointed Limesurvey users missing certain core features.

Change other position: https://survey-consulting.com/product/limesurvey-plugin-change-other-position
Demo survey: https://plugins.mysurveyhosting.com/index.php/survey/index/sid/941344/newtest/Y/lang/en

Add text fields to arrays: https://survey-consulting.com/product/array-with-other-free-text-limesurvey-plugin/
Demo survey: https://plugins.mysurveyhosting.com/index.php/362484?newtest=Y&amp;lang=en

As you can see, it is now that difficult to implement and rather simple to use.

Issue History

Date Modified Username Field Change
2013-08-30 13:09 jelo Note Added: 26113
2013-08-30 14:22 mfaber Issue Monitored: mfaber
2014-12-05 16:17 jelo Note Added: 31183
2015-06-16 00:42 jelo Note Added: 32375
2015-08-11 17:40 holch Note Added: 32901
2015-08-14 10:58 Mazi Note Added: 32955
2016-04-05 08:59 Mazi Note Added: 36999
2016-04-06 13:12 jelo Note Added: 37039
2016-04-13 20:34 trivender Note Added: 37357
2016-09-25 22:41 jelo File Added: otherfields.editor.JPG
2016-09-25 22:41 jelo Note Added: 40951
2016-11-14 12:28 LouisGac Assigned To => LouisGac
2016-11-14 12:28 LouisGac Status acknowledged => assigned
2016-12-02 11:14 DenisChenu Note Added: 42314
2016-12-07 15:16 DenisChenu Note Added: 42446
2016-12-07 15:22 DenisChenu Note Added: 42447
2016-12-07 16:05 jelo Note Added: 42453
2016-12-08 08:50 DenisChenu Relationship added related to 11988
2019-08-06 01:58 tixeon Note Added: 53118
2019-08-06 01:58 tixeon Issue Monitored: tixeon
2019-11-01 17:25 c_schmitz Category Survey design => Survey editing
2020-12-04 16:30 joka77 Note Added: 60840
2020-12-04 17:33 Mazi Note Added: 60841
2020-12-04 22:37 tixeon Note Added: 60842
2020-12-04 22:37 tixeon File Added: Put other further up the list.txt
2020-12-05 11:53 jelo Note Added: 60843
2021-11-25 10:22 galads Additional Information Updated
2021-11-25 10:22 LimeBot Zoho Projects URL => https://projects.limesurvey.org/portal/limesurvey#taskdetail/85781000001335039/85781000001348001/85781000001461007
2021-11-25 10:22 galads Assigned To LouisGac => galads
2021-11-25 10:39 jelo Note Added: 67559
2021-11-25 10:39 jelo File Added: image.png
2021-11-25 10:39 jelo File Added: image-2.png
2021-11-25 12:02 Mazi Note Added: 67568
2021-12-01 03:06 jelo Note Added: 67613
2021-12-22 18:30 gabrieljenik Note Added: 67847
2021-12-22 18:30 gabrieljenik Bug heat 20 => 22
2021-12-22 18:35 DenisChenu Note Added: 67848
2021-12-22 18:38 gabrieljenik Note Added: 67849
2021-12-22 18:50 holch Note Added: 67850
2021-12-22 18:54 gabrieljenik Note Added: 67851
2021-12-22 19:04 holch Note Added: 67852
2021-12-22 19:04 DenisChenu Note Added: 67853
2021-12-22 19:19 holch Note Added: 67854
2021-12-22 19:49 holch Note Added: 67855
2021-12-22 21:03 jelo Note Added: 67856
2021-12-23 08:56 DenisChenu Note Added: 67857
2021-12-23 11:21 jelo Note Added: 67858
2021-12-23 11:21 jelo File Added: image-3.png
2022-01-11 15:21 galads Status assigned => ready for code review
2022-04-28 12:46 Mazi Note Added: 69283
2022-05-24 17:04 DenisChenu Assigned To galads =>